diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/test/wifi-mac-ofdma-test.cc ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc
--- ns-3.37/src/wifi/test/wifi-mac-ofdma-test.cc	2022-11-01 17:37:24.763395800 -0700
+++ ns-3.38/src/wifi/test/wifi-mac-ofdma-test.cc	2023-03-16 20:54:23.872869300 -0700
@@ -878,415 +1221,645 @@
         NS_TEST_EXPECT_MSG_EQ(blockAck.GetAckType(i), true, "Expected All-ack context");
         NS_TEST_EXPECT_MSG_EQ(+blockAck.GetTidInfo(i), 14, "Expected All-ack context");
     }
-    tEnd = m_txPsdus[9].endTx;
-    tStart = m_txPsdus[10].startTx;
+    tEnd = m_txPsdus[19].endTx;
+    tStart = m_txPsdus[20].startTx;
     NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Multi-STA Block Ack sent too early");
     NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Multi-STA Block Ack sent too late");
-
-    navEnd = m_txPsdus[5].endTx + m_txPsdus[5].psduMap[SU_STA_ID]->GetDuration(); // Basic TF's NAV
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[10].endTx,
-                                "Duration/ID in Basic Trigger Frame is too short");
-    navEnd = m_txPsdus[6].endTx +
-             m_txPsdus[6].psduMap.begin()->second->GetDuration(); // 1st QoS Data frame's NAV
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[10].endTx,
-                                "Duration/ID in 1st QoS Data frame is too short");
-    navEnd = m_txPsdus[7].endTx +
-             m_txPsdus[7].psduMap.begin()->second->GetDuration(); // 2nd QoS Data frame's NAV
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[10].endTx,
-                                "Duration/ID in 2nd QoS Data frame is too short");
-    navEnd = m_txPsdus[8].endTx +
-             m_txPsdus[8].psduMap.begin()->second->GetDuration(); // 3rd QoS Data frame's NAV
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[10].endTx,
-                                "Duration/ID in 3rd QoS Data frame is too short");
-    navEnd = m_txPsdus[9].endTx +
-             m_txPsdus[9].psduMap.begin()->second->GetDuration(); // 4th QoS Data frame's NAV
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                m_txPsdus[10].endTx,
-                                "Duration/ID in 4th QoS Data frame is too short");
+    auto multiStaBaNavEnd = m_txPsdus[20].endTx + m_txPsdus[20].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= multiStaBaNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd,
+                                multiStaBaNavEnd,
+                                "Duration/ID in Multi-STA BlockAck is too short");
+    NS_TEST_EXPECT_MSG_LT(multiStaBaNavEnd,
+                          navEnd + tolerance,
+                          "Duration/ID in Multi-STA BlockAck is too long");
+
+    // the AP sends an MU-RTS Trigger Frame to protect the DL MU PPDU
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 26, "Expected at least 26 transmitted packet");
+    NS_TEST_EXPECT_MSG_EQ((m_txPsdus[21].psduMap.size() == 1 &&
+                           m_txPsdus[21].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger() &&
+                           m_txPsdus[21].psduMap[SU_STA_ID]->GetHeader(0).GetAddr1().IsBroadcast()),
+                          true,
+                          "Expected a Trigger Frame");
+    m_txPsdus[21].psduMap[SU_STA_ID]->GetPayload(0)->PeekHeader(trigger);
+    NS_TEST_EXPECT_MSG_EQ(trigger.IsMuRts(), true, "Expected an MU-RTS Trigger Frame");
+    NS_TEST_EXPECT_MSG_EQ(trigger.GetNUserInfoFields(),
+                          4,
+                          "Expected one User Info field per station");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[21].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the MU-RTS to occupy the entire channel width");
+    for (const auto& userInfo : trigger)
+    {
+        NS_TEST_EXPECT_MSG_EQ(+userInfo.GetMuRtsRuAllocation(),
+                              +m_muRtsRuAllocation,
+                              "Unexpected RU Allocation value in MU-RTS");
+    }
+    tEnd = m_txPsdus[20].endTx;
+    tStart = m_txPsdus[21].startTx;
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(tEnd + ifs, tStart, "MU-RTS Trigger Frame sent too early");
+    tEnd = m_txPsdus[21].endTx;
+    navEnd = tEnd + m_txPsdus[21].psduMap[SU_STA_ID]->GetDuration();
+
+    // A first STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[22].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[22].psduMap.size() == 1 &&
+         m_txPsdus[22].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[22].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[22].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[22].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[22].endTx + m_txPsdus[22].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A second STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[23].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[23].psduMap.size() == 1 &&
+         m_txPsdus[23].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[23].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[23].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[23].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[23].endTx + m_txPsdus[23].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A third STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[24].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[24].psduMap.size() == 1 &&
+         m_txPsdus[24].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[24].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[24].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[24].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[24].endTx + m_txPsdus[24].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
+
+    // A fourth STA sends a CTS frame a SIFS after the reception of the MU-RTS TF
+    NS_TEST_EXPECT_MSG_EQ(
+        (m_txPsdus[25].txVector.GetPreambleType() != WIFI_PREAMBLE_HE_TB &&
+         m_txPsdus[25].psduMap.size() == 1 &&
+         m_txPsdus[25].psduMap.begin()->second->GetNMpdus() == 1 &&
+         m_txPsdus[25].psduMap.begin()->second->GetHeader(0).GetType() == WIFI_MAC_CTL_CTS),
+        true,
+        "Expected a CTS frame");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[25].txVector.GetChannelWidth(),
+                          m_channelWidth,
+                          "Expected the CTS to occupy the entire channel width");
+
+    tStart = m_txPsdus[25].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "CTS frame sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "CTS frame sent too late");
+    ctsNavEnd = m_txPsdus[25].endTx + m_txPsdus[25].psduMap[SU_STA_ID]->GetDuration();
+    // navEnd <= ctsNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, ctsNavEnd, "Duration/ID in CTS frame is too short");
+    NS_TEST_EXPECT_MSG_LT(ctsNavEnd, navEnd + tolerance, "Duration/ID in CTS frame is too long");
 
     // the AP sends a DL MU PPDU
-    NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 12, "Expected at least 12 transmitted packet");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].txVector.GetPreambleType(),
-                          WIFI_PREAMBLE_HE_MU,
+    NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 27, "Expected at least 27 transmitted packet");
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[26].txVector.GetPreambleType(),
+                          m_dlMuPreamble,
                           "Expected a DL MU PPDU");
-    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].psduMap.size(),
+    NS_TEST_EXPECT_MSG_EQ(m_txPsdus[26].psduMap.size(),
                           4,
                           "Expected 4 PSDUs within the DL MU PPDU");
     // the TX duration cannot exceed the maximum PPDU duration
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(m_txPsdus[11].endTx - m_txPsdus[11].startTx,
-                                GetPpduMaxTime(m_txPsdus[11].txVector.GetPreambleType()),
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(m_txPsdus[26].endTx - m_txPsdus[26].startTx,
+                                GetPpduMaxTime(m_txPsdus[26].txVector.GetPreambleType()),
                                 "TX duration cannot exceed max PPDU duration");
-    for (auto& psdu : m_txPsdus[11].psduMap)
+    for (auto& psdu : m_txPsdus[26].psduMap)
     {
         NS_TEST_EXPECT_MSG_LT_OR_EQ(psdu.second->GetSize(),
                                     m_maxAmpduSize,
                                     "Max A-MPDU size exceeded");
     }
-    tEnd = m_txPsdus[10].endTx;
-    tStart = m_txPsdus[11].startTx;
-    NS_TEST_EXPECT_MSG_LT_OR_EQ(tEnd + ifs, tStart, "DL MU PPDU sent too early");
+    tEnd = m_txPsdus[25].endTx;
+    tStart = m_txPsdus[26].startTx;
+    NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "DL MU PPDU sent too early");
+    NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "DL MU PPDU sent too late");
 
     // The Duration/ID field is the same for all the PSDUs
-    navEnd = m_txPsdus[11].endTx;
-    for (auto& psdu : m_txPsdus[11].psduMap)
+    auto dlMuNavEnd = m_txPsdus[26].endTx;
+    for (auto& psdu : m_txPsdus[26].psduMap)
     {
-        if (navEnd == m_txPsdus[11].endTx)
+        if (dlMuNavEnd == m_txPsdus[26].endTx)
         {
-            navEnd += psdu.second->GetDuration();
+            dlMuNavEnd += psdu.second->GetDuration();
         }
         else
         {
-            NS_TEST_EXPECT_MSG_EQ(m_txPsdus[11].endTx + psdu.second->GetDuration(),
-                                  navEnd,
+            NS_TEST_EXPECT_MSG_EQ(m_txPsdus[26].endTx + psdu.second->GetDuration(),
+                                  dlMuNavEnd,
                                   "Duration/ID must be the same for all PSDUs");
         }
     }
-    NS_TEST_EXPECT_MSG_GT(navEnd,
-                          m_txPsdus[11].endTx,
-                          "Duration/ID of the DL MU PPDU cannot be zero");
+    // navEnd <= dlMuNavEnd < navEnd + tolerance
+    NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, dlMuNavEnd, "Duration/ID in DL MU PPDU is too short");
+    NS_TEST_EXPECT_MSG_LT(dlMuNavEnd, navEnd + tolerance, "Duration/ID in DL MU PPDU is too long");
 
     std::size_t nTxPsdus = 0;
 
     if (m_dlMuAckType == WifiAcknowledgment::DL_MU_BAR_BA_SEQUENCE)
     {
         /*
-         *        |----------------------------------------NAV---------------------------------------------->|
-         *        | |--------------------------NAV---------------------------------->| | |
-         * |-------------------NAV--------------->| |                         | | |----NAV---->|
-         * |------|      |-----|      |-----|      |-----|      |-----|      |-----|      |-----|
-         * |-----| |PSDU 1|      |     |      |     |      |     |      |     |      |     |      |
-         * |      |     |
-         * |------|      |Block|      |Block|      |Block|      |Block|      |Block|      |Block|
-         * |Block| |PSDU 2|      | Ack |      | Ack |      | Ack |      | Ack |      | Ack |      |
-         * Ack |      | Ack |
-         * |------|<SIFS>|     |<SIFS>| Req |<SIFS>|     |<SIFS>| Req |<SIFS>|     |<SIFS>| Req
-         * |<SIFS>|     | |PSDU 3|      |     |      |     |      |     |      |     |      |     |
-         * |     |      |     |
-         * |------|      |     |      |     |      |     |      |     |      |     |      |     | |
-         * | |PSDU 4|      |     |      |     |      |     |      |     |      |     |      |     |
-         * |     |
-         * ---------------------------------------------------------------------------------------------------
-         * From: AP       STA 1         AP          STA 2         AP          STA 3         AP STA 4
-         *   To:           AP          STA 2         AP          STA 3         AP          STA 4 AP
+         *        |-----------------------------------------NAV-------------------------------->|
+         *                 |----------------------------------NAV------------------------------>|
+         *                           |-----------------------------NAV------------------------->|
+         *                                   |-------------------------NAV--------------------->|
+         *                                            |--NAV->|        |--NAV->|        |--NAV->|
+         *    ┌───┐    ┌───┐    ┌────┐    ┌──┐    ┌───┐    ┌──┐    ┌───┐    ┌──┐    ┌───┐    ┌──┐
+         *    │   │    │   │    │PSDU│    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    │  1 │    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    ├────┤    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    │PSDU│    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │MU-│    │CTS│    │  2 │    │BA│    │BAR│    │BA│    │BAR│    │BA│    │BAR│    │BA│
+         *    │RTS│SIFS│   │SIFS├────┤SIFS│  │SIFS│   │SIFS│  │SIFS│   │SIFS│  │SIFS│   │SIFS│  │
+         *    │TF │    │x4 │    │PSDU│    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    │  3 │    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    ├────┤    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    │PSDU│    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         *    │   │    │   │    │  4 │    │  │    │   │    │  │    │   │    │  │    │   │    │  │
+         * ───┴───┴────┴───┴────┴────┴────┴──┴────┴───┴────┴──┴────┴───┴────┴──┴────┴───┴────┴──┴──
+         * From: AP     all       AP      STA 1    AP     STA 2     AP      STA 3    AP      STA 4
+         *   To: all    AP        all      AP     STA 2     AP     STA 3     AP     STA 4     AP
          */
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 19, "Expected at least 19 packets");
+        NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 34, "Expected at least 34 packets");
 
         // A first STA sends a Block Ack a SIFS after the reception of the DL MU PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[12].psduMap.size() == 1 &&
-                               m_txPsdus[12].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[27].psduMap.size() == 1 &&
+                               m_txPsdus[27].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[11].endTx;
-        tStart = m_txPsdus[12].startTx;
+        tEnd = m_txPsdus[26].endTx;
+        tStart = m_txPsdus[27].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "First Block Ack sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "First Block Ack sent too late");
+        Time baNavEnd = m_txPsdus[27].endTx + m_txPsdus[27].psduMap[SU_STA_ID]->GetDuration();
+        // The NAV of the first BlockAck, being a response to a QoS Data frame, matches the NAV
+        // set by the MU-RTS TF.
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd,
+                                    baNavEnd,
+                                    "Duration/ID in 1st BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in 1st BlockAck is too long");
 
         // the AP transmits a Block Ack Request an IFS after the reception of the Block Ack
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[13].psduMap.size() == 1 &&
-                               m_txPsdus[13].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAckReq()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[28].psduMap.size() == 1 &&
+                               m_txPsdus[28].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAckReq()),
                               true,
                               "Expected a Block Ack Request");
-        tEnd = m_txPsdus[12].endTx;
-        tStart = m_txPsdus[13].startTx;
+        tEnd = m_txPsdus[27].endTx;
+        tStart = m_txPsdus[28].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "First Block Ack Request sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "First Block Ack Request sent too late");
+        // under single protection setting (TXOP limit equal to zero), the NAV of the BlockAckReq
+        // only covers the following BlockAck response; under multiple protection setting, the
+        // NAV of the BlockAckReq matches the NAV set by the MU-RTS TF
+        Time barNavEnd = m_txPsdus[28].endTx + m_txPsdus[28].psduMap[SU_STA_ID]->GetDuration();
+        if (m_txopLimit > 0)
+        {
+            // navEnd <= barNavEnd < navEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd,
+                                        barNavEnd,
+                                        "Duration/ID in BlockAckReq is too short");
+            NS_TEST_EXPECT_MSG_LT(barNavEnd,
+                                  navEnd + tolerance,
+                                  "Duration/ID in BlockAckReq is too long");
+        }
 
         // A second STA sends a Block Ack a SIFS after the reception of the Block Ack Request
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[14].psduMap.size() == 1 &&
-                               m_txPsdus[14].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[29].psduMap.size() == 1 &&
+                               m_txPsdus[29].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[13].endTx;
-        tStart = m_txPsdus[14].startTx;
+        tEnd = m_txPsdus[28].endTx;
+        tStart = m_txPsdus[29].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Second Block Ack sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Second Block Ack sent too late");
+        baNavEnd = m_txPsdus[29].endTx + m_txPsdus[29].psduMap[SU_STA_ID]->GetDuration();
+        if (m_txopLimit > 0)
+        {
+            // navEnd <= baNavEnd < navEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck is too short");
+            NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                                  navEnd + tolerance,
+                                  "Duration/ID in BlockAck is too long");
+        }
+        else
+        {
+            // barNavEnd <= baNavEnd < barNavEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(barNavEnd,
+                                        baNavEnd,
+                                        "Duration/ID in BlockAck is too short");
+            NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                                  barNavEnd + tolerance,
+                                  "Duration/ID in BlockAck is too long");
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[29].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
         // the AP transmits a Block Ack Request an IFS after the reception of the Block Ack
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[15].psduMap.size() == 1 &&
-                               m_txPsdus[15].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAckReq()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[30].psduMap.size() == 1 &&
+                               m_txPsdus[30].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAckReq()),
                               true,
                               "Expected a Block Ack Request");
-        tEnd = m_txPsdus[14].endTx;
-        tStart = m_txPsdus[15].startTx;
+        tEnd = m_txPsdus[29].endTx;
+        tStart = m_txPsdus[30].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Second Block Ack Request sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Second Block Ack Request sent too late");
+        // under single protection setting (TXOP limit equal to zero), the NAV of the BlockAckReq
+        // only covers the following BlockAck response; under multiple protection setting, the
+        // NAV of the BlockAckReq matches the NAV set by the MU-RTS TF
+        barNavEnd = m_txPsdus[30].endTx + m_txPsdus[30].psduMap[SU_STA_ID]->GetDuration();
+        if (m_txopLimit > 0)
+        {
+            // navEnd <= barNavEnd < navEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd,
+                                        barNavEnd,
+                                        "Duration/ID in BlockAckReq is too short");
+            NS_TEST_EXPECT_MSG_LT(barNavEnd,
+                                  navEnd + tolerance,
+                                  "Duration/ID in BlockAckReq is too long");
+        }
 
         // A third STA sends a Block Ack a SIFS after the reception of the Block Ack Request
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[16].psduMap.size() == 1 &&
-                               m_txPsdus[16].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[31].psduMap.size() == 1 &&
+                               m_txPsdus[31].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[15].endTx;
-        tStart = m_txPsdus[16].startTx;
+        tEnd = m_txPsdus[30].endTx;
+        tStart = m_txPsdus[31].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Third Block Ack sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Third Block Ack sent too late");
+        baNavEnd = m_txPsdus[31].endTx + m_txPsdus[31].psduMap[SU_STA_ID]->GetDuration();
+        if (m_txopLimit > 0)
+        {
+            // navEnd <= baNavEnd < navEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck is too short");
+            NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                                  navEnd + tolerance,
+                                  "Duration/ID in BlockAck is too long");
+        }
+        else
+        {
+            // barNavEnd <= baNavEnd < barNavEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(barNavEnd,
+                                        baNavEnd,
+                                        "Duration/ID in BlockAck is too short");
+            NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                                  barNavEnd + tolerance,
+                                  "Duration/ID in BlockAck is too long");
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[31].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
         // the AP transmits a Block Ack Request an IFS after the reception of the Block Ack
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[17].psduMap.size() == 1 &&
-                               m_txPsdus[17].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAckReq()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[32].psduMap.size() == 1 &&
+                               m_txPsdus[32].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAckReq()),
                               true,
                               "Expected a Block Ack Request");
-        tEnd = m_txPsdus[16].endTx;
-        tStart = m_txPsdus[17].startTx;
+        tEnd = m_txPsdus[31].endTx;
+        tStart = m_txPsdus[32].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Third Block Ack Request sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Third Block Ack Request sent too late");
+        // under single protection setting (TXOP limit equal to zero), the NAV of the BlockAckReq
+        // only covers the following BlockAck response; under multiple protection setting, the
+        // NAV of the BlockAckReq matches the NAV set by the MU-RTS TF
+        barNavEnd = m_txPsdus[32].endTx + m_txPsdus[32].psduMap[SU_STA_ID]->GetDuration();
+        if (m_txopLimit > 0)
+        {
+            // navEnd <= barNavEnd < navEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd,
+                                        barNavEnd,
+                                        "Duration/ID in BlockAckReq is too short");
+            NS_TEST_EXPECT_MSG_LT(barNavEnd,
+                                  navEnd + tolerance,
+                                  "Duration/ID in BlockAckReq is too long");
+        }
 
         // A fourth STA sends a Block Ack a SIFS after the reception of the Block Ack Request
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[18].psduMap.size() == 1 &&
-                               m_txPsdus[18].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[33].psduMap.size() == 1 &&
+                               m_txPsdus[33].psduMap[SU_STA_ID]->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[17].endTx;
-        tStart = m_txPsdus[18].startTx;
+        tEnd = m_txPsdus[32].endTx;
+        tStart = m_txPsdus[33].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Fourth Block Ack sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart, tEnd + sifs + tolerance, "Fourth Block Ack sent too late");
-
+        baNavEnd = m_txPsdus[33].endTx + m_txPsdus[33].psduMap[SU_STA_ID]->GetDuration();
         if (m_txopLimit > 0)
         {
-            // DL MU PPDU's NAV
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[18].endTx,
-                                        "Duration/ID in the DL MU PPDU is too short");
-            // 1st BlockAckReq's NAV
-            navEnd = m_txPsdus[13].endTx + m_txPsdus[13].psduMap[SU_STA_ID]->GetDuration();
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[18].endTx,
-                                        "Duration/ID in the 1st BlockAckReq is too short");
-            // 2nd BlockAckReq's NAV
-            navEnd = m_txPsdus[15].endTx + m_txPsdus[15].psduMap[SU_STA_ID]->GetDuration();
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[18].endTx,
-                                        "Duration/ID in the 2nd BlockAckReq is too short");
-            // 3rd BlockAckReq's NAV
-            navEnd = m_txPsdus[17].endTx + m_txPsdus[17].psduMap[SU_STA_ID]->GetDuration();
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[18].endTx,
-                                        "Duration/ID in the 3rd BlockAckReq is too short");
+            // navEnd <= baNavEnd < navEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck is too short");
+            NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                                  navEnd + tolerance,
+                                  "Duration/ID in BlockAck is too long");
         }
-        nTxPsdus = 19;
+        else
+        {
+            // barNavEnd <= baNavEnd < barNavEnd + tolerance
+            NS_TEST_EXPECT_MSG_LT_OR_EQ(barNavEnd,
+                                        baNavEnd,
+                                        "Duration/ID in BlockAck is too short");
+            NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                                  barNavEnd + tolerance,
+                                  "Duration/ID in BlockAck is too long");
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[33].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
+
+        nTxPsdus = 34;
     }
     else if (m_dlMuAckType == WifiAcknowledgment::DL_MU_TF_MU_BAR)
     {
         /*
-         *             |----------------NAV--------------->|
-         *             |                |--------NAV------>|
-         *      |------|      |---------|      |-----------|
-         *      |PSDU 1|      |         |      |Block Ack 1|
-         *      |------|      | MU-BAR  |      |-----------|
-         *      |PSDU 2|      | Trigger |      |Block Ack 2|
-         *      |------|<SIFS>|  Frame  |<SIFS>|-----------|
-         *      |PSDU 3|      |         |      |Block Ack 3|
-         *      |------|      |         |      |-----------|
-         *      |PSDU 4|      |         |      |Block Ack 4|
-         * --------------------------------------------------
-         * From:   AP            AP
-         *   To:                all                 AP
+         *          |---------------------NAV------------------------>|
+         *                   |-------------------NAV----------------->|
+         *                               |---------------NAV--------->|
+         *                                            |------NAV----->|
+         *      ┌───┐    ┌───┐    ┌──────┐    ┌───────┐    ┌──────────┐
+         *      │   │    │   │    │PSDU 1│    │       │    │BlockAck 1│
+         *      │   │    │   │    ├──────┤    │MU-BAR │    ├──────────┤
+         *      │MU-│    │CTS│    │PSDU 2│    │Trigger│    │BlockAck 2│
+         *      │RTS│SIFS│   │SIFS├──────┤SIFS│ Frame │SIFS├──────────┤
+         *      │TF │    │x4 │    │PSDU 3│    │       │    │BlockAck 3│
+         *      │   │    │   │    ├──────┤    │       │    ├──────────┤
+         *      │   │    │   │    │PSDU 4│    │       │    │BlockAck 4│
+         * -----┴───┴────┴───┴────┴──────┴────┴───────┴────┴──────────┴───
+         * From: AP       all        AP          AP            all
+         *   To: all      AP         all         all           AP
          */
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 17, "Expected at least 17 packets");
+        NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 32, "Expected at least 32 packets");
 
-        // the AP transmits a MU-BAR Trigger Frame an IFS after the transmission of the DL MU PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[12].psduMap.size() == 1 &&
-                               m_txPsdus[12].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger()),
+        // the AP transmits a MU-BAR Trigger Frame a SIFS after the transmission of the DL MU PPDU
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[27].psduMap.size() == 1 &&
+                               m_txPsdus[27].psduMap[SU_STA_ID]->GetHeader(0).IsTrigger()),
                               true,
                               "Expected a MU-BAR Trigger Frame");
-        tEnd = m_txPsdus[11].endTx;
-        tStart = m_txPsdus[12].startTx;
+        tEnd = m_txPsdus[26].endTx;
+        tStart = m_txPsdus[27].startTx;
         NS_TEST_EXPECT_MSG_EQ(tStart, tEnd + sifs, "MU-BAR Trigger Frame sent at wrong time");
-
-        // A first STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[13].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[13].psduMap.size() == 1 &&
-                               m_txPsdus[13].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        auto muBarNavEnd = m_txPsdus[27].endTx + m_txPsdus[27].psduMap[SU_STA_ID]->GetDuration();
+        // navEnd <= muBarNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd,
+                                    muBarNavEnd,
+                                    "Duration/ID in MU-BAR Trigger Frame is too short");
+        NS_TEST_EXPECT_MSG_LT(muBarNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in MU-BAR Trigger Frame is too long");
+
+        // A first STA sends a Block Ack in a TB PPDU a SIFS after the reception of the MU-BAR
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[28].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[28].psduMap.size() == 1 &&
+                               m_txPsdus[28].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[12].endTx;
-        tStart = m_txPsdus[13].startTx;
+        tEnd = m_txPsdus[27].endTx;
+        tStart = m_txPsdus[28].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
+        Time baNavEnd = m_txPsdus[28].endTx + m_txPsdus[28].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd, navEnd + tolerance, "Duration/ID in BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[28].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
-        // A second STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[14].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[14].psduMap.size() == 1 &&
-                               m_txPsdus[14].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        // A second STA sends a Block Ack in a TB PPDU a SIFS after the reception of the MU-BAR
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[29].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[29].psduMap.size() == 1 &&
+                               m_txPsdus[29].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[12].endTx;
-        tStart = m_txPsdus[14].startTx;
+        tStart = m_txPsdus[29].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
+        baNavEnd = m_txPsdus[29].endTx + m_txPsdus[29].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in 1st BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[29].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
-        // A third STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[15].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[15].psduMap.size() == 1 &&
-                               m_txPsdus[15].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        // A third STA sends a Block Ack in a TB PPDU a SIFS after the reception of the MU-BAR
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[30].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[30].psduMap.size() == 1 &&
+                               m_txPsdus[30].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[12].endTx;
-        tStart = m_txPsdus[15].startTx;
+        tStart = m_txPsdus[30].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
+        baNavEnd = m_txPsdus[30].endTx + m_txPsdus[30].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in 1st BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[30].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
-        // A fourth STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[16].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[16].psduMap.size() == 1 &&
-                               m_txPsdus[16].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        // A fourth STA sends a Block Ack in a TB PPDU a SIFS after the reception of the MU-BAR
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[31].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[31].psduMap.size() == 1 &&
+                               m_txPsdus[31].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[12].endTx;
-        tStart = m_txPsdus[16].startTx;
+        tStart = m_txPsdus[31].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
-
-        if (m_txopLimit > 0)
+        baNavEnd = m_txPsdus[31].endTx + m_txPsdus[31].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd,
+                              navEnd + tolerance,
+                              "Duration/ID in 1st BlockAck is too long");
+        if (m_txopLimit == 0)
         {
-            // DL MU PPDU's NAV
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[13].endTx,
-                                        "Duration/ID in the DL MU PPDU is too short");
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[14].endTx,
-                                        "Duration/ID in the DL MU PPDU is too short");
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[15].endTx,
-                                        "Duration/ID in the DL MU PPDU is too short");
-            NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                        m_txPsdus[16].endTx,
-                                        "Duration/ID in the DL MU PPDU is too short");
-        }
-        // MU-BAR Trigger Frame's NAV
-        navEnd = m_txPsdus[12].endTx + m_txPsdus[12].psduMap[SU_STA_ID]->GetDuration();
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[13].endTx,
-                                    "Duration/ID in the MU-BAR Trigger Frame is too short");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[14].endTx,
-                                    "Duration/ID in the MU-BAR Trigger Frame is too short");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[15].endTx,
-                                    "Duration/ID in the MU-BAR Trigger Frame is too short");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[16].endTx,
-                                    "Duration/ID in the MU-BAR Trigger Frame is too short");
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[31].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
-        nTxPsdus = 17;
+        nTxPsdus = 32;
     }
     else if (m_dlMuAckType == WifiAcknowledgment::DL_MU_AGGREGATE_TF)
     {
         /*
-         *                         |--------NAV------>|
-         *      |------|-----------|      |-----------|
-         *      |PSDU 1|MU-BAR TF 1|      |Block Ack 1|
-         *      |------------------|      |-----------|
-         *      |PSDU 2|MU-BAR TF 2|      |Block Ack 2|
-         *      |------------------|<SIFS>|-----------|
-         *      |PSDU 3|MU-BAR TF 3|      |Block Ack 3|
-         *      |------------------|      |-----------|
-         *      |PSDU 4|MU-BAR TF 4|      |Block Ack 4|
-         * --------------------------------------------------
-         * From:         AP
-         *   To:                               AP
+         *          |---------------------NAV----------------------->|
+         *                   |-------------------NAV---------------->|
+         *                                           |------NAV----->|
+         *      ┌───┐    ┌───┐    ┌──────┬───────────┐    ┌──────────┐
+         *      │   │    │   │    │PSDU 1│MU-BAR TF 1│    │BlockAck 1│
+         *      │   │    │   │    ├──────┼───────────┤    ├──────────┤
+         *      │MU-│    │CTS│    │PSDU 2│MU-BAR TF 2│    │BlockAck 2│
+         *      │RTS│SIFS│   │SIFS├──────┼───────────┤SIFS├──────────┤
+         *      │TF │    │x4 │    │PSDU 3│MU-BAR TF 3│    │BlockAck 3│
+         *      │   │    │   │    ├──────┼───────────┤    ├──────────┤
+         *      │   │    │   │    │PSDU 4│MU-BAR TF 4│    │BlockAck 4│
+         * -----┴───┴────┴───┴────┴──────┴───────────┴────┴──────────┴───
+         * From: AP       all            AP                    all
+         *   To: all      AP             all                   AP
          */
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(m_txPsdus.size(), 16, "Expected at least 16 packets");
+        NS_TEST_ASSERT_MSG_GT_OR_EQ(m_txPsdus.size(), 31, "Expected at least 31 packets");
 
         // The last MPDU in each PSDU is a MU-BAR Trigger Frame
-        for (auto& psdu : m_txPsdus[11].psduMap)
+        for (auto& psdu : m_txPsdus[26].psduMap)
         {
-            NS_TEST_EXPECT_MSG_EQ((*(--psdu.second->end()))->GetHeader().IsTrigger(),
+            NS_TEST_EXPECT_MSG_EQ((*std::prev(psdu.second->end()))->GetHeader().IsTrigger(),
                                   true,
                                   "Expected an aggregated MU-BAR Trigger Frame");
         }
 
-        // A first STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[12].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[12].psduMap.size() == 1 &&
-                               m_txPsdus[12].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        // A first STA sends a Block Ack in a TB PPDU a SIFS after the reception of the DL MU PPDU
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[27].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[27].psduMap.size() == 1 &&
+                               m_txPsdus[27].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[11].endTx;
-        tStart = m_txPsdus[12].startTx;
+        tEnd = m_txPsdus[26].endTx;
+        tStart = m_txPsdus[27].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[12].endTx,
-                                    "Duration/ID in the DL MU PPDU is too short");
-
-        // A second STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[13].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[13].psduMap.size() == 1 &&
-                               m_txPsdus[13].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        Time baNavEnd = m_txPsdus[27].endTx + m_txPsdus[27].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd, navEnd + tolerance, "Duration/ID in BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[27].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
+
+        // A second STA sends a Block Ack in a TB PPDU a SIFS after the reception of the DL MU PPDU
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[28].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[28].psduMap.size() == 1 &&
+                               m_txPsdus[28].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[11].endTx;
-        tStart = m_txPsdus[13].startTx;
+        tStart = m_txPsdus[28].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[13].endTx,
-                                    "Duration/ID in the DL MU PPDU is too short");
-
-        // A third STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[14].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[14].psduMap.size() == 1 &&
-                               m_txPsdus[14].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        baNavEnd = m_txPsdus[28].endTx + m_txPsdus[28].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd, navEnd + tolerance, "Duration/ID in BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[28].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
+
+        // A third STA sends a Block Ack in a TB PPDU a SIFS after the reception of the DL MU PPDU
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[29].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[29].psduMap.size() == 1 &&
+                               m_txPsdus[29].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[11].endTx;
-        tStart = m_txPsdus[14].startTx;
+        tStart = m_txPsdus[29].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[14].endTx,
-                                    "Duration/ID in the DL MU PPDU is too short");
-
-        // A fourth STA sends a Block Ack in an HE TB PPDU a SIFS after the reception of the DL MU
-        // PPDU
-        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[15].txVector.GetPreambleType() == WIFI_PREAMBLE_HE_TB &&
-                               m_txPsdus[15].psduMap.size() == 1 &&
-                               m_txPsdus[15].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
+        baNavEnd = m_txPsdus[29].endTx + m_txPsdus[29].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd, navEnd + tolerance, "Duration/ID in BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[29].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
+
+        // A fourth STA sends a Block Ack in a TB PPDU a SIFS after the reception of the DL MU PPDU
+        NS_TEST_EXPECT_MSG_EQ((m_txPsdus[30].txVector.GetPreambleType() == m_tbPreamble &&
+                               m_txPsdus[30].psduMap.size() == 1 &&
+                               m_txPsdus[30].psduMap.begin()->second->GetHeader(0).IsBlockAck()),
                               true,
                               "Expected a Block Ack");
-        tEnd = m_txPsdus[11].endTx;
-        tStart = m_txPsdus[15].startTx;
+        tStart = m_txPsdus[30].startTx;
         NS_TEST_EXPECT_MSG_LT(tEnd + sifs, tStart, "Block Ack in HE TB PPDU sent too early");
         NS_TEST_EXPECT_MSG_LT(tStart,
                               tEnd + sifs + tolerance,
                               "Block Ack in HE TB PPDU sent too late");
-        NS_TEST_EXPECT_MSG_GT_OR_EQ(navEnd + tolerance,
-                                    m_txPsdus[15].endTx,
-                                    "Duration/ID in the DL MU PPDU is too short");
+        baNavEnd = m_txPsdus[30].endTx + m_txPsdus[30].psduMap.begin()->second->GetDuration();
+        // navEnd <= baNavEnd < navEnd + tolerance
+        NS_TEST_EXPECT_MSG_LT_OR_EQ(navEnd, baNavEnd, "Duration/ID in BlockAck frame is too short");
+        NS_TEST_EXPECT_MSG_LT(baNavEnd, navEnd + tolerance, "Duration/ID in BlockAck is too long");
+        if (m_txopLimit == 0)
+        {
+            NS_TEST_EXPECT_MSG_EQ(baNavEnd,
+                                  m_txPsdus[30].endTx,
+                                  "Expected null Duration/ID for BlockAck");
+        }
 
-        nTxPsdus = 16;
+        nTxPsdus = 31;
     }
 
     NS_TEST_EXPECT_MSG_EQ(m_received,
